#!/usr/bin/perl

$xmin = shift || undef;
$xmax = shift || undef;
$ymin = shift || undef;
$ymax = shift || undef;
$zmin = shift || undef;
$zmax = shift || undef;
$color = shift || "Blue";
$t = shift || 0.85;
$dx = shift || 0;

$bulbfile = "./bulb.out.pov";


open(BULBS,"$bulbfile") || die "Can't open $bublfile:$!\n";
while (<BULBS>) {
    chomp;
    s/^bulb\(// || next ;
    s/\)$// || next;
    ($c, $x, $y, $z ) = split(",",$_);
    next if $x > $xmax || $x < $xmin;
    next if $y > $ymax || $y < $ymin;
    next if $z > $zmax || $z < $zmin;
    push(@candidate,join(":",$c,$x,$y,$z));
}
close(BULBS);

die "No candidate bulbs!!\n" unless @candidate;

@col = grep(/$color/,@candidate);
if ( @col ) {
    #we have at least one of the right color - take the first

    ($c, $x, $y, $z) = split(":",$col[0]);
    $y -= 2; # The bulb is 2 inches below the point in the macro
}
elsif ( @candidate ) {
    # none the right color, but ther is at least one in the right area
    
    ($c, $x, $y, $z) = split(":",$candidate[0]);
}
else {
    die "No bulbs in the area (shouldn't ever see this)\n";
}

$bx = 0, $by = 3.5, $bz = 0;

$cx = $bx + ($t * ( $x - $bx)) +$dx;
$cy = $by + ($t * ( $y - $by));
$cz = $bz + ($t * ( $z - $bz));

print <<END;
camera {
    location <$cx, $cy, $cz>
    look_at <$x,$y,$z>
}
END
